Index: lab3/kbc.d
===================================================================
--- lab3/kbc.d	(revision 34)
+++ lab3/kbc.d	(nonexistent)
@@ -1,45 +0,0 @@
-kbc.o: kbc.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h kbc.h kbc_func.h

Property changes on: lab3/kbc.d
___________________________________________________________________
Deleted: svn:executable
Index: lab3/output.txt
===================================================================
--- lab3/output.txt	(revision 34)
+++ lab3/output.txt	(nonexistent)

Property changes on: lab3/output.txt
___________________________________________________________________
Deleted: svn:executable
Index: lab3/trace.txt
===================================================================
--- lab3/trace.txt	(revision 34)
+++ lab3/trace.txt	(nonexistent)

Property changes on: lab3/trace.txt
___________________________________________________________________
Deleted: svn:executable
Index: lab3/utils.d
===================================================================
--- lab3/utils.d	(revision 34)
+++ lab3/utils.d	(nonexistent)
@@ -1,45 +0,0 @@
-utils.o: utils.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h

Property changes on: lab3/utils.d
___________________________________________________________________
Deleted: svn:executable
Index: lab3/lab3.d
===================================================================
--- lab3/lab3.d	(revision 34)
+++ lab3/lab3.d	(nonexistent)
@@ -1,45 +0,0 @@
-lab3.o: lab3.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h kbc.h kbc_func.h

Property changes on: lab3/lab3.d
___________________________________________________________________
Deleted: svn:executable