Index: proj/project/include/campaign.h
===================================================================
--- proj/project/include/campaign.h	(revision 356)
+++ proj/project/include/campaign.h	(revision 357)
@@ -1,6 +1,19 @@
 #ifndef CAMPAIGN_H_INCLUDED
 #define CAMPAIGN_H_INCLUDED
 
+/**
+ * @defgroup    campaign    campaign
+ * @ingroup proj
+ * @ingroup singleplayer
+ * @brief   Campaign mode.
+ *
+ * @{
+ */
+
 int (campaign)(void);
 
+/**
+ * @}
+ */
+
 #endif //CAMPAIGN_H_INCLUDED
Index: proj/project/include/chat.h
===================================================================
--- proj/project/include/chat.h	(revision 356)
+++ proj/project/include/chat.h	(revision 357)
@@ -1,6 +1,18 @@
 #ifndef CHAT_H_INCLUDED
 #define CHAT_H_INCLUDED
 
+/**
+ * @defgroup    chat    chat
+ * @ingroup proj
+ * @brief   Chat module.
+ *
+ * @{
+ */
+
 int (chat)(void);
 
+/**
+ * @}
+ */
+
 #endif //CHAT_H_INCLUDED
Index: proj/project/include/ent.h
===================================================================
--- proj/project/include/ent.h	(revision 356)
+++ proj/project/include/ent.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup ent ent
+ * @ingroup proj
  * @brief Entities module
  *
  * @{
Index: proj/project/include/hltp.h
===================================================================
--- proj/project/include/hltp.h	(revision 356)
+++ proj/project/include/hltp.h	(revision 357)
@@ -3,7 +3,7 @@
 
 /**
  * @defgroup    hltp    hltp
- * @ingroup nctp
+ * @ingroup proj
  * @brief HLTP (High-Level Transfer Protocol) module.
  *
  * @{
Index: proj/project/include/interrupts_func.h
===================================================================
--- proj/project/include/interrupts_func.h	(revision 356)
+++ proj/project/include/interrupts_func.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup interrupts_func interrupts_func
+ * @ingroup proj
  * @brief Interrupts functions.
  *
  * @{
Index: proj/project/include/makecode_map.h
===================================================================
--- proj/project/include/makecode_map.h	(revision 356)
+++ proj/project/include/makecode_map.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup makecode_map makecode_map
+ * @ingroup proj
  * @brief Makecode map.
  *
  * @{
Index: proj/project/include/proj.h
===================================================================
--- proj/project/include/proj.h	(revision 356)
+++ proj/project/include/proj.h	(revision 357)
@@ -1,6 +1,13 @@
 #ifndef PROJ_H_INCLUDED
 #define PROJ_H_INCLUDED
 
+/**
+ * @defgroup proj proj
+ * @brief Project module.
+ *
+ * @{
+ */
+
 #include "libs.h"
 
 #include "ent.h"
@@ -14,4 +21,8 @@
 map_t                *map1         ;
 sprite_t             *sp_crosshair ;
 
+/**
+ * @}
+ */
+
 #endif //PROJ_H_INCLUDED
Index: proj/project/include/proj_func.h
===================================================================
--- proj/project/include/proj_func.h	(revision 356)
+++ proj/project/include/proj_func.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup proj_func proj_func
+ * @ingroup proj
  * @brief Project helper functions.
  *
  * @{
Index: proj/project/include/proj_macros.h
===================================================================
--- proj/project/include/proj_macros.h	(revision 356)
+++ proj/project/include/proj_macros.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup proj_macros proj_macros
+ * @ingroup proj
  * @brief Project macros.
  *
  * @{
Index: proj/project/include/proj_structures.h
===================================================================
--- proj/project/include/proj_structures.h	(revision 356)
+++ proj/project/include/proj_structures.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup proj_structures proj_structures
+ * @ingroup proj
  * @brief Project structures.
  *
  * @{
Index: proj/project/include/scoreboards.h
===================================================================
--- proj/project/include/scoreboards.h	(revision 356)
+++ proj/project/include/scoreboards.h	(revision 357)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup scoreboards scoreboards
+ * @ingroup proj
  * @brief Scoreboards module.
  *
  * @{
Index: proj/project/include/singleplayer.h
===================================================================
--- proj/project/include/singleplayer.h	(revision 356)
+++ proj/project/include/singleplayer.h	(revision 357)
@@ -1,6 +1,18 @@
 #ifndef SINGLEPLAYER_H_INCLUDED
 #define SINGLEPLAYER_H_INCLUDED
 
+/**
+ * @defgroup    singleplayer    singleplayer
+ * @ingroup proj
+ * @brief   Single player module.
+ *
+ * @{
+ */
+
 int (singleplayer)(void);
 
+/**
+ * @}
+ */
+
 #endif //SINGLEPLAYER_H_INCLUDED
Index: proj/project/include/zombies.h
===================================================================
--- proj/project/include/zombies.h	(revision 356)
+++ proj/project/include/zombies.h	(revision 357)
@@ -1,6 +1,19 @@
 #ifndef ZOMBIES_H_INCLUDED
 #define ZOMBIES_H_INCLUDED
 
+/**
+ * @defgroup    zombies    zombies
+ * @ingroup proj
+ * @ingroup singleplayer
+ * @brief   Zombies mode.
+ *
+ * @{
+ */
+
 int (zombies)(void);
 
+/**
+ * @}
+ */
+
 #endif //ZOMBIES_H_INCLUDED
Index: proj/Doxyfile
===================================================================
--- proj/Doxyfile	(revision 356)
+++ proj/Doxyfile	(revision 357)
@@ -790,7 +790,7 @@
 # spaces. See also FILE_PATTERNS and EXTENSION_MAPPING
 # Note: If this tag is empty the current directory is searched.
 
-INPUT                  = ./include ./libs ./libs/graph/include ./libs/kbc/include ./libs/rtc/include ./libs/timer/include ./libs/uart/include ./libs/classes/include ./libs/utils/include ./maps ./media/xpm
+INPUT                  = ./project/include ./libs ./libs/graph/include ./libs/kbc/include ./libs/rtc/include ./libs/timer/include ./libs/uart/include ./libs/classes/include ./libs/utils/include ./maps ./media/xpm
 
 # This tag can be used to specify the character encoding of the source files
 # that doxygen parses. Internally doxygen uses the UTF-8 encoding. Doxygen uses
@@ -3284,7 +3284,7 @@
 # spaces. See also FILE_PATTERNS and EXTENSION_MAPPING
 # Note: If this tag is empty the current directory is searched.
 
-INPUT                  = ./include ./libs ./libs/graph/include ./libs/kbc/include ./libs/rtc/include ./libs/timer/include ./libs/uart/include ./libs/classes/include ./libs/utils/include ./maps ./media/xpm
+INPUT                  = ./project/include ./libs ./libs/graph/include ./libs/kbc/include ./libs/rtc/include ./libs/timer/include ./libs/uart/include ./libs/classes/include ./libs/utils/include ./maps ./media/xpm
 
 # This tag can be used to specify the character encoding of the source files
 # that doxygen parses. Internally doxygen uses the UTF-8 encoding. Doxygen uses