Index: proj/src/libs/uart/src/uart.c
===================================================================
--- proj/src/libs/uart/src/uart.c	(revision 383)
+++ proj/src/libs/uart/src/uart.c	(revision 384)
@@ -316,7 +316,7 @@
 //#define NCTP_END        0xFF
 #define NCTP_OK         0xFF
 #define NCTP_NOK        0x00
-#define NCTP_ALIGN      8
+#define NCTP_ALIGN      4
 #define NCTP_FILLER     0x4E
 
 static queue_t *out = NULL;
@@ -372,6 +372,7 @@
     for(size_t i = 0; i < num_fillers; ++i){
         tmp = malloc(sizeof(uint8_t)); *tmp = NCTP_FILLER; queue_push(out, tmp);
     }
+    printf("Sent message\n");
 
     if(uart_transmitter_empty(COM1_ADDR)){
         if((ret = uart_send_char(COM1_ADDR, *(uint8_t*)queue_top(out)))) return ret;
@@ -388,7 +389,7 @@
     }/*else*/ return SUCCESS;
 }
 
-static void nctp_process_received(){
+static void nctp_process_received(){ printf("Process received");
     uint16_t sz = 0;{
         uint8_t sz0 = *(uint8_t*)queue_top(in); free(queue_top(in)); queue_pop(in);
         uint8_t sz1 = *(uint8_t*)queue_top(in); free(queue_top(in)); queue_pop(in);
@@ -417,6 +418,8 @@
         if((ret = uart_get_char(COM1_ADDR, &c))) return ret;
         uint8_t *tmp = malloc(sizeof(uint8_t)); *tmp = c;
 
+        printf("Received char 0x%02X\n", c);
+
         if       (szbytes_to_receive){ // gotta receive 2nd size byte and update num_bytes
             *((uint8_t*)(&num_bytes_to_receive)+0) = size0;
             *((uint8_t*)(&num_bytes_to_receive)+1) = c;
@@ -447,16 +450,16 @@
 
 static int nctp_ih_err = SUCCESS;
 int (nctp_get_ih_error)(void){ return nctp_ih_err; }
-void nctp_ih(void){
+void nctp_ih(void){ printf("Got UART interrupt: ");
     uint8_t iir;
     if((nctp_ih_err = uart_get_iir(COM1_ADDR, &iir))) return;
     if(UART_GET_IF_INT_PEND(iir)){
         switch(UART_GET_INT_PEND(iir)){
-            case uart_int_rx: nctp_receive (); break;
-            case uart_int_tx: nctp_transmit(); break;
-            case uart_int_receiver_line_stat: break;
-            case uart_int_modem_stat: break;
-            case uart_int_char_timeout_fifo: break;
+            case uart_int_rx: printf("receive\n"); nctp_receive (); break;
+            case uart_int_tx: printf("transmit\n"); nctp_transmit(); break;
+            case uart_int_receiver_line_stat: printf("receiver line stat\n"); break;
+            case uart_int_modem_stat: printf("modem state\n"); break;
+            case uart_int_char_timeout_fifo: printf("char timeout\n"); nctp_receive (); break;
             //default: break;
         }
     }
Index: proj/src/project/src/interrupts_func.c
===================================================================
--- proj/src/project/src/interrupts_func.c	(revision 383)
+++ proj/src/project/src/interrupts_func.c	(revision 384)
@@ -129,7 +129,7 @@
     uart_set_bits_per_character(COM1_ADDR, 8);
     uart_set_stop_bits         (COM1_ADDR, 2);
     uart_set_parity            (COM1_ADDR, uart_parity_even);
-    uart_set_bit_rate          (COM1_ADDR, 19200);
+    uart_set_bit_rate          (COM1_ADDR, 5760);
     uart_enable_int_rx (COM1_ADDR);
     uart_enable_int_tx(COM1_ADDR);
     if(subscribe_uart_interrupt(COM1_IRQ, &uart_id)) {
Index: proj/src/project/src/proj.c
===================================================================
--- proj/src/project/src/proj.c	(revision 383)
+++ proj/src/project/src/proj.c	(revision 384)
@@ -368,14 +368,14 @@
                     break;
 
                     case COM1_IRQ:
-                        printf("Reach\n");
+                        printf("L371\n");
                         nctp_ih();
-                            printf("Reach2\n");
-                        if (bullet_info->new_bullet) {
+                        printf("L373\n");
+                        if (bullet_info->new_bullet) { printf("L374\n");
                             shoot_bullet(shooter2, bullet_list, bsp_bullet);
                             bullet_info->new_bullet = false;
                         }
-                            printf("Reach1\n");
+                        printf("L378\n");
                         break;
                 }
             }